# Chapter 4 : Web servers

Back to [Course Introduction](../../README.md)

Web servers are an importand foundation of the IT ecosystem. </br>
The internet is fundamentally made up of web servers. </br>
In this chapter we'll learn about the basics of web servers and get our first web server up and running. </br>

### 🚧🎬 [Module 1: Introduction to Web](../../content/web/README.md)

#### In this module

* What is a web server
* Run a very basic web server
* Basics of Web
  - Client & Server
  - HTTP 
  - DNS
  - Status code
  - Request methods
  - TCP\UDP and Ports
  - Network testing tools

### 🚧🎬 Module 2: The basics of HTML and Web

DevOps engineers are often tasked to troubleshoot and assist developers who may have Web applications deployed. </br>
Perhaps there are network failures, resources may not be correctly loading or incorrectly deployed. </br>
In this chapter we will learn about the basics of HTML and web assets, how they render and how to use developer tools to troubleshoot networking and other issues with Web applications. 

#### In this module

* HTML files, syntax and usage
* Basics of Stylesheets
* Troubleshooting HTML in Browsers
* Monitoring and Debugging

### 🚧🎬 Module 3: Creating web servers with NGINX

#### In this module

* Installing NGINX Web server
* Understand the NGINX configuration
* Setup a basic web site with a few pages
* Make our website public
* Understanding SSL\TLS security for Web servers

### 🚧🎬 Module 4: Creating our own personal website

During this entire course we will touch on a wide spectrum of DevOps tooling, concepts and technology. </br>
The outcome of this course is to have real-world hands-on experience with all these topics, all the way from setup, scripting, coding to building, CI/CD and deployment including monitoring and observability. </br>

#### In this module

* Put together a DevOps CV personal website using HTML, CSS and Javascript
* Understanding website deployment and changes

### 🎬 Module 5: Get free SSL certificates

To make our website public on the web, we should introduce a domain and SSL certificate

#### In this module

* Setup domain for your website
* Understanding SSL\TLS
* Introduction to Let's encrypt